// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include "ET199_32.h"
#include <ostream.h>

#pragma comment(lib, "ET199_32S.lib")


void FlipBuffer(unsigned char* pBuf, unsigned long ulLen)
{
	unsigned char ucTemp;
	for(unsigned long i = 0; i < ulLen >> 1; ++i)
	{
		ucTemp = pBuf[i];
		pBuf[i] = pBuf[ulLen - i - 1];
		pBuf[ulLen - i - 1] = ucTemp;
	}
}

void Hex2Str(unsigned char* pIN, unsigned char* pOut, unsigned long ulLen)
{
	BYTE bTemp = 0;
	for(DWORD i=0; i<ulLen; ++i)
	{
		bTemp = pIN[i] >> 4;// & 0x0F;
		bTemp = bTemp & 0x0F;
	
		if((bTemp>=0x00) && (bTemp<=0x09))
			bTemp = bTemp + 0x30;
		else if((bTemp >= 0x0A) && (bTemp <= 0x0F))
			bTemp = bTemp + 0x37;

		pOut[2*i] = bTemp;

		bTemp = pIN[i] & 0x0F;

		if((bTemp>=0x00) && (bTemp<=0x09))
			bTemp = bTemp + 0x30;
		else if((bTemp >= 0x0A) && (bTemp <= 0x0F))
			bTemp = bTemp + 0x37;

		pOut[2*i + 1] = bTemp;
	}

}


int main(int argc, char* argv[])
{

	

	DWORD dwRet;
	DWORD dwCount=0;
	ET_CONTEXT *pContext;

	BYTE pbOut[256] = {0};
	DWORD dwOutLen = 0;
	DWORD dwOut = 0;


	
	//öET199
	dwRet=ETEnum(NULL,&dwCount);

	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		return dwRet;

	//ڴڴ洢CONTEXTṹ
	pContext = new ET_CONTEXT[dwCount];

	//0
	memset(pContext,0,sizeof(ET_CONTEXT)*dwCount);

	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
		return dwRet;

	//printf("Find ET199 %d\n",dwCount);

	//ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
		return dwRet;


	//ִгǰҪ֤û
	dwRet = ETVerifyPin(&pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(dwRet)
	{
		printf("ETVerifyPin Error:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}


	//ǩݡ123456
	BYTE pbSignRes[6] = {0x31,0x32,0x33,0x34,0x35,0x36};


	dwRet = ETExecute(&pContext[0],"0001",pbSignRes,6,pbOut,256, &dwOutLen);
	if(dwRet)
	{
		printf("ETExecute Error:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}
	
	ETClose(&pContext[0]);
	delete [] pContext;

	for(int i=0;i<128;++i)
	{
		printf("%02X ",pbOut[i]);
		if((i+1)%16 == 0)
			printf("\n");
	}
	
	return 0;
}
